<?php

add_filter( 'pre_update_option_mailcamp_api_url',           'mailcamp_encrypt_value', 10, 2 );
add_filter( 'pre_update_option_mailcamp_admin',             'mailcamp_encrypt_value', 10, 2 );
add_filter( 'pre_update_option_mailcamp_admin_token',       'mailcamp_encrypt_value', 10, 2 );
add_filter( 'pre_update_option_mailcamp_user',              'mailcamp_encrypt_value', 10, 2 );
add_filter( 'pre_update_option_mailcamp_user_token',        'mailcamp_encrypt_value', 10, 2 );

function mailcamp_encrypt_value( $new_value, $old_value ) {
	return mailcamp_encrypt( $new_value );
}


function mailcamp_encrypt($stringToHandle = "", $encrypt = true){

    $secret_key = get_option('mailcamp_hash_key');
    $secret_iv  = get_option('mailcamp_hash_vector');
    
    if(empty($secret_key)):
        $secret_key = mailcamp_random_string();
        update_option('mailcamp_hash_key', $secret_key);
    endif;
    if(empty($secret_iv)):
        $secret_iv = mailcamp_random_string();
        update_option('mailcamp_hash_vector', $secret_iv);
    endif;

    // Set default output value
    $output     = null;
    $key        = hash('sha256',$secret_key);
    $iv         = substr(hash('sha256',$secret_iv),0,16); // using salt technique

    // Check whether encryption or decryption
    if($encrypt):
        $output = base64_encode(openssl_encrypt($stringToHandle,"AES-256-CBC",$key,0,$iv));
    else:
        $output = openssl_decrypt(base64_decode($stringToHandle),"AES-256-CBC",$key,0,$iv);
    endif;

    return $output;
}

function mailcamp_random_string($length = 24) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[random_int(0, $charactersLength - 1)];
    }
    return $randomString;
}