<?php
add_action( 'admin_init',  'mailcamp_register_setting' );

function mailcamp_register_setting(){
	add_settings_section(
		'mailcamp_settings_for_api', // section ID
		'', // title (if needed)
		'', // callback function (if needed)
		'mailcamp-imagro-slug' // page slug
	);

	register_setting('mailcamp_settings', 'mailcamp_encrypted', 'sanitize_text_field');
	add_settings_field(
		'mailcamp_encrypted',
		'MailCamp Encryption',
		function(){
			mailcamp_imagro_field_html('mailcamp_encrypted', [
				'type' 		=> 'hidden',
				'default' 	=> 1,
			]);
		},
		'mailcamp-imagro-slug', // page slug
		'mailcamp_settings_for_api', // section ID
		array( 
			'label_for' => 'mailcamp_encrypted',
			// 'class' => 'hidden', // for <tr> element
		)
	);

	register_setting('mailcamp_settings', 'mailcamp_api_url', 'sanitize_text_field');
	add_settings_field(
		'mailcamp_api_url',
		'MailCamp API URL',
		function(){
			mailcamp_imagro_field_html('mailcamp_api_url', [
				'encrypted' => true,
			]);
		},
		'mailcamp-imagro-slug', // page slug
		'mailcamp_settings_for_api', // section ID
		array( 
			'label_for' => 'mailcamp_api_url',
			'class' => 'mailcamp-class', // for <tr> element
		)
	);

	register_setting('mailcamp_settings', 'mailcamp_admin', 'sanitize_text_field');
	add_settings_field(
		'mailcamp_admin',
		'MailCamp admin username',
		function(){
			mailcamp_imagro_field_html('mailcamp_admin', [
				'encrypted' => true,
			]);
		},
		'mailcamp-imagro-slug', // page slug
		'mailcamp_settings_for_api', // section ID
		array( 
			'label_for' => 'mailcamp_admin',
			'class' => 'mailcamp-class', // for <tr> element
		)
	);
	
	register_setting('mailcamp_settings', 'mailcamp_admin_token', 'sanitize_text_field'	);
	add_settings_field(
		'mailcamp_admin_token',
		'MailCamp admin token',
		function(){
			mailcamp_imagro_field_html('mailcamp_admin_token', [
				'type' 		=> 'password',
				'encrypted' => true,
			]);
		},
		'mailcamp-imagro-slug', // page slug
		'mailcamp_settings_for_api', // section ID
		array( 
			'label_for' => 'mailcamp_admin_token',
			'class' => 'mailcamp-class', // for <tr> element
		)
	);

	register_setting('mailcamp_settings', 'mailcamp_user', 'sanitize_text_field');
	add_settings_field(
		'mailcamp_user',
		'MailCamp username',
		function(){
			mailcamp_imagro_field_html('mailcamp_user', [
				'encrypted' => true,
			]);
		},
		'mailcamp-imagro-slug', // page slug
		'mailcamp_settings_for_api', // section ID
		array( 
			'label_for' => 'mailcamp_user',
			'class' => 'mailcamp-class', // for <tr> element
		)
	);
	
	register_setting('mailcamp_settings', 'mailcamp_user_token', 'sanitize_text_field');
	add_settings_field(
		'mailcamp_user_token',
		'MailCamp user token',
		function(){
			mailcamp_imagro_field_html('mailcamp_user_token', [
				'type' 		=> 'password',
				'encrypted' => true,
			]);
		},
		'mailcamp-imagro-slug', // page slug
		'mailcamp_settings_for_api', // section ID
		array( 
			'label_for' => 'mailcamp_user_token',
			'class' => 'mailcamp-class', // for <tr> element
		)
	);

}

function mailcamp_imagro_field_html($name, $params = []){
	global $mailcampConfig;

	// Set value
	$text = get_option($name);
	if(empty($text) && isset($params['default'])):
		$text = $params['default'];
	endif;

	// Set type
	$type = 'text';
	if(isset($params['type']) && !empty($params['type'])):
		$type = $params['type'];
	endif;

	if((isset($params['encrypted']) && $params['encrypted'] == true) && $mailcampConfig['encrypted'] == true):
		$text = mailcamp_encrypt($text, false);
	endif;

	$attributes 	= [];
	$attributes[] 	= 'type="'.$type.'"';
	$attributes[] 	= 'id="'.$name.'"';
	$attributes[] 	= 'name="'.$name.'"';
	$attributes[] 	= 'value="'.esc_attr( $text ).'"';
	
	echo '<input '.implode(" ", $attributes).' />';
}