<?php

/*
 * $res empty at this step
 * $action 'plugin_information'
 * $args stdClass Object ( [slug] => woocommerce [is_ssl] => [fields] => Array ( [banners] => 1 [reviews] => 1 [downloaded] => [active_installs] => 1 ) [per_page] => 24 [locale] => en_US )
 */
function imagro_plugin_info( $res, $action, $args ){

	// do nothing if this is not about getting plugin information
	if( 'plugin_information' !== $action ) return false;
	
	$plugin_info = get_plugin_data(IMAGRO_TOOLS_FILE);

	// do nothing if it is not our plugin
	if( $plugin_info['TextDomain'] !== $args->slug ) return false;

	// info.json is the file with the actual plugin information on your server
	$remote = wp_remote_get( 
		IMAGRO_TOOLS_AUTO_UPDATE_URL, 
		array(
			'timeout' => 5,
			'headers' => array(
				'Accept' => 'application/json'
			) 
		)
	);

	// do nothing if we don't get the correct response from the server
	if( is_wp_error( $remote )
		|| 200 !== wp_remote_retrieve_response_code( $remote )
		|| empty( wp_remote_retrieve_body( $remote ) 
	)) {
		return false;	
	}

	$remote = json_decode( wp_remote_retrieve_body( $remote ) );
	
	if(isset($remote->sections))	$remote->sections 		= json_decode(json_encode($remote->sections),true); 
	if(isset($remote->banners))		$remote->banners 		= json_decode(json_encode($remote->banners),true); 
	if(isset($remote->icons))		$remote->icons 			= json_decode(json_encode($remote->icons),true); 
	
	return $remote;

}
		
		