<?php

function imagro_mailcamp_push_update( $transient ){
	if ( empty( $transient->checked ) ) {return $transient;	}
	
	$allowedURLS = array(
		'/wp-admin/update-core.php',
		'/wp-admin/plugins.php',
		'/wp-admin/network/update-core.php',
		'/wp-admin/network/plugins.php',
	);
	
	// Only check for updates on "Update core" and "Plugins" page
	if(!in_array($_SERVER['REQUEST_URI'], $allowedURLS)) return $transient;
	
	$remote = wp_remote_get( 
		AUTO_UPDATE_URL,
		array(
			'timeout' 	=> 2,
			'headers' 	=> array(
				'Accept' => 'application/json',
			),
			'sslverify' => false,
		)
	);
	
	if( is_wp_error( $remote )
		|| 200 !== wp_remote_retrieve_response_code( $remote )
		|| empty( wp_remote_retrieve_body( $remote ) 
	)) {
		return $transient;	
	}
	
	$remote = json_decode( wp_remote_retrieve_body( $remote ) );
	
	// your installed plugin version should be on the line below! You can obtain it dynamically of course 
	if(
		$remote
		&& version_compare( get_plugin_data(IMAGRO_MAILCAMP_FILE)['Version'], $remote->new_version, '<' )
		&& version_compare( $remote->requires, get_bloginfo( 'version' ), '<' )
		&& version_compare( $remote->requires_php, PHP_VERSION, '<' )
	) {
		
		if(isset($remote->sections))	$remote->sections 		= json_decode(json_encode($remote->sections),true); 
		if(isset($remote->banners))		$remote->banners 		= json_decode(json_encode($remote->banners),true); 
		if(isset($remote->icons))		$remote->icons 			= json_decode(json_encode($remote->icons),true); 
		
		$transient->response[ plugin_basename( IMAGRO_MAILCAMP_FILE ) ] = $remote;
	}
 
	return $transient;

}

